#include "AppleMachine-skelimpl.h"
#include "apple-orbit-library.h"
#include "examples-toolkit.h"

CORBA_ORB global_orb;
PortableServer_POA rootpoa;
PortableServer_POAManager rootpoa_mgr; 

typedef struct _Servant Servant;
struct _Servant
{
	PortableServer_POA poa;
	CORBA_Object servant;
};

int main (int argc, char **argv)
{
	GList *servants = NULL;
	Servant *thrower = g_new0 (Servant, 1),
			*picker = g_new0 (Servant, 1),
			*control = g_new0 (Servant, 1);
	CORBA_Environment ev[1];
	CORBA_exception_init(ev);

	server_init (&argc, argv, &global_orb, ev);

	thrower->poa = server_create_multi_threaded_poa 
			(global_orb, rootpoa, rootpoa_mgr, "ThrowerPOA", ev);
	thrower->servant = impl_AppleMachine_Thrower__create (thrower->poa, ev);
	etk_abort_if_exception(ev, "failed activating service thrower");
	etk_export_object_to_file (global_orb, thrower->servant, "thrower.ior", ev);
	etk_abort_if_exception(ev, "failed exporting IOR for thrower");
	servants = g_list_append (servants, thrower);

	picker->poa = server_create_multi_threaded_poa 
			(global_orb, rootpoa, rootpoa_mgr, "PickerPOA", ev);
	picker->servant = impl_AppleMachine_Picker__create (picker->poa, ev);
	etk_abort_if_exception(ev, "failed activating service picker");
	etk_export_object_to_file (global_orb, picker->servant, "picker.ior", ev);
	etk_abort_if_exception(ev, "failed exporting IOR for picker");
	servants = g_list_append (servants, picker);

	control->poa = server_create_multi_threaded_poa 
			(global_orb, rootpoa, rootpoa_mgr, "ControlPOA", ev);
	control->servant = impl_AppleMachine_Control__create (control->poa, ev);
	etk_abort_if_exception(ev, "failed activating service control");
	etk_export_object_to_file (global_orb, control->servant, "control.ior", ev);
	etk_abort_if_exception(ev, "failed exporting IOR for control");
	servants = g_list_append (servants, control);


	server_run (global_orb, ev);
	etk_abort_if_exception(ev, "failed entering main loop");

	while (servants)
	{
		Servant *servant = servants->data;
		server_cleanup (global_orb, servant->poa, servant->servant, ev);
		etk_abort_if_exception(ev, "failed cleanup");
		servants = g_list_next (servants);
	}

	return 0;
}
